package kagent.test.main;
import java.util.Date;
import java.util.Properties;

import org.drools.io.ResourceChangeScanner;
import org.drools.io.ResourceChangeScannerConfiguration;
import org.drools.io.ResourceFactory;

import kagent.test.DroolsEngineService;
import kagent.test.DroolsEngineServiceImpl;
import kagent.test.TemporalDroolsEngineServiceImpl;
import kagent.test.changeset.notifficator.DroolsEngineResourceNotifier;
import kagent.test.rulemodel.TestModel;


public class MainTemporal {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		String drlRulePath = args[0];
		
		Properties props = new Properties();
		props.setProperty("drools.resource.scanner.interval", "10");
		ResourceChangeScanner service = ResourceFactory
				.getResourceChangeScannerService();
		ResourceChangeScannerConfiguration rconf = service
				.newResourceChangeScannerConfiguration(props);
		service.configure(rconf);
		service.start();
		ResourceFactory.getResourceChangeNotifierService().start();
		
		DroolsEngineService des = new TemporalDroolsEngineServiceImpl(drlRulePath,"myEngine", new Object[]{}, null , "var/");
		
		DroolsEngineResourceNotifier dern = new DroolsEngineResourceNotifier(des);
		
		ResourceFactory.getResourceChangeNotifierService()
		.subscribeResourceChangeListener(dern,
				ResourceFactory.newUrlResource(drlRulePath));
		
		TestModel tm;
		while (true){
			tm = new TestModel();
			tm.setId(System.currentTimeMillis());
			tm.setEvent_date(new Date(System.currentTimeMillis()));
			tm.setTest("1");			
			des.insertFact(tm);			
			try {
				Thread.sleep(5000);
			} catch (InterruptedException e) {
			}
		}
	}
}